<?php
$ip=$_SERVER['REMOTE_ADDR']; 
//Получаем ip
$date=date('d.m.y',time()); 
//Присваиваем переменной $date текущую дату

//Следующий блок считывает файл с ip адресами
$fo=fopen ("ip.dat", 'r'); 
//Открываем файл
flock($fo,1); 
//"Запираем" файл для чтения. Если кто-то ещё захочет прочитать этот файл - его запрос "встанет в очередь"
$data=fread ($fo, filesize("ip.dat")); 
//Считываем информацию из файла и присваиваем её переменной $data
flock($fo,3); 
// Разблокируем файл
fclose ($fo); 
//Закрываем файл

//Нижеследующий блок повторяет ту же самую процедуру с файлом counter.txt
$f=fopen ("counter.dat", 'r');
flock($f,1);
$counts=fread ($f, filesize("counter.dat"));
flock($f,3);
fclose ($f);

list($d,$total,$hits,$hosts)=explode("|",$counts);// Проходимся по данным счётчика и присваиваем их соответствующим переменным. 

//Проверяем, соответствует ли дата в файле счётчика текущей дате. 

if ($d!=$date)
{
$d=$date; 
//Обновляем дату
$hits=0; 
//Просмотров сегодня теперь равны нулю
$hosts=0; 
//То же самое с уникальными посетителями
$erase=fopen("ip.dat",'w+'); 
//Открываем файл с ключём "w+" - это значит, что данные файла обнуляются и на их место мы записываем новые данные
flock($erase,2); 
//Запираем файл для записи
fputs($erase,""); 
//Записываем в файл "всемирное ничто"
flock($erase,3);
fclose($erase);
}


//Теперь проверяем, есть ли ip у нас в базе.
if (!stristr($data,$ip)) 
// Если нет
{
$file=fopen("ip.dat",'a');
flock($file,2);
fputs($file,$ip."\r\n"); 
//Записываем новый ip в базу
flock($file,3);
fclose($file);
$total++; 
$hits++;
$hosts++;
//Прибавляем к значениям счётчика по единице
}
else 
//Если ip уже есть в базе, прибавляем по единице только хитам
{
$total++;
$hits++;
}

//Записываем новые данные счётчика в файл
$wfile=fopen("counter.dat",'w+');
flock($wfile,2);
fputs($wfile,$d."|".$total."|".$hits."|".$hosts); 
//Записываем данные с разделителем ("|"), для удобной сортировки, которую мы проводили выше
flock($wfile,3);
fclose($wfile);

// Подключаем подсчет онлайн
include "online.php";

//Всё, теперь можно выдавать пользователю показатели счётчика
echo "Online: $online<br />
Всего: $total<br />
Хиты: $hits<br/>
Хосты: $hosts";
?>